<script lang="ts">
import Vue from 'vue';
import { SolutionsVideoModal } from '~/components/solutions/index.vue';
import { UseLiteVimeo, UseLocalizedVideoSubtitles } from '~/mixins';

export default Vue.extend({
  name: 'FeatureItemCard',
  components: {
    SolutionsVideoModal,
  },
  mixins: [UseLiteVimeo, UseLocalizedVideoSubtitles],
  props: {
    data: {
      type: Object,
      required: true,
    },
    titleTag: {
      type: String,
      required: false,
      default: 'h5',
    },
    gaLocation: {
      type: String,
      required: false,
      default: 'body',
    },
  },
  data() {
    return {
      modal: {
        open: false,
      },
    };
  },
  methods: {
    handleClick() {
      this.modal.open = true;
      // Make sure Vimeo analytics work:
      // https://vimeo.zendesk.com/hc/en-us/articles/115002859607-Integrate-the-Vimeo-player-with-Google-Tag-Manager
      setTimeout(() => {
        window.__vimeoRefresh();
      }, 3000);
    },
    closeModal() {
      this.modal.open = false;
    },
  },
});
</script>

<template>
  <div>
    <div class="feature-item-card">
      <div v-if="data.header" class="feature-item-card__header slp-mb-16">
        <SlpTypography tag="span" variant="body2">
          {{ data.header }}
        </SlpTypography>
      </div>
      <div class="feature-item-card__body slp-mb-48">
        <SlpTypography :tag="titleTag" variant="heading5-bold" class="slp-mb-16"
          >{{ data.title }}
        </SlpTypography>
        <div class="text" v-html="$md.render(data.description)"></div>
      </div>
      <div class="feature-item-card__footer">
        <div class="cta">
          <SlpIcon
            v-if="data.video"
            class="slp-ml-8"
            name="video"
            variant="marketing"
            color="#7759C2"
            alt="video Icon"
          />
          <SlpButton
            v-if="data.video"
            variant="tertiary"
            :aria-label="data.video.data_ga_name"
            :data-ga-name="data.video.data_ga_name"
            :data-ga-location="gaLocation"
            @click.native="handleClick"
          >
            <SlpTypography tag="span" variant="body3-bold">
              Watch Video
            </SlpTypography>
            <SlpIcon
              class="slp-ml-8"
              name="chevron-lg-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
        </div>
        <div class="cta">
          <SlpIcon
            class="slp-ml-8"
            name="docs"
            variant="marketing"
            alt="Docs Icon"
            color="#7759C2"
          />
          <SlpButton
            v-if="data.link"
            variant="tertiary"
            :href="data.link"
            :aria-label="data.link_description"
            :data-ga-name="data.link_description"
            :data-ga-location="gaLocation"
          >
            <SlpTypography tag="span" variant="body3-bold">
              Read Documentation
            </SlpTypography>
            <SlpIcon
              class="slp-ml-8"
              name="chevron-lg-right"
              variant="product"
              alt="Chevron Right Icon"
            />
          </SlpButton>
        </div>
      </div>
    </div>
    <div v-if="data.video">
      <SolutionsVideoModal
        v-show="modal.open"
        light-background
        :visible="modal.open"
        @close="closeModal"
      >
        <template #body>
          <lite-vimeo
            ref="video"
            :videoid="getVimeoVideoId(createVideoSource(data.video.url))"
            :videotitle="getVimeoVideoId(data.video.url)"
            autoplay
          ></lite-vimeo>
        </template>
      </SolutionsVideoModal>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.feature-item-card {
  height: 100%;
  padding: $spacing-32 0;
  border-top: 1px solid var(--slp-color-surface-100, #f2f1f5);
  border-radius: $border-radius-4;
  display: flex;
  flex-direction: column;
  @media (min-width: $breakpoint-lg) {
    gap: 48px;
    flex-direction: row;
  }
  &__body {
    flex-basis: 75%;

    .text {
      font-size: $font-size-default;
      line-height: $line-height-body-2;
      font-weight: $font-weight-normal;
    }
  }

  &__footer {
    display: flex;
    flex-basis: 25%;
    flex-direction: column;
    justify-content: center;
    @media (max-width: $breakpoint-lg) {
      flex-direction: row;
      justify-content: flex-start;
    }
    &:deep() {
      a {
        color: $color-text-link-100;
        padding: 0;
      }

      button {
        color: $color-text-link-100;
        min-width: auto;
      }
    }

    & > *:nth-child(2) {
      border-radius: 0;
    }

    &__icon {
      width: 24px;
      height: 24px;
    }
  }
}

.cta {
  display: flex;
  gap: 8px;
  align-items: center;
}
</style>
